2 # Copyright (c) 2005 Junio C Hamano
4 # This program is free software: you can redistribute it and/or modify
5 # it under the terms of the GNU General Public License as published by
6 # the Free Software Foundation, either version 2 of the License, or
7 # (at your option) any later version.
9 # This program is distributed in the hope that it will be useful,
10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
12 # GNU General Public License for more details.
14 # You should have received a copy of the GNU General Public License
15 # along with this program. If not, see http://www.gnu.org/licenses/ .
17 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
18 echo "Error: The notmuch test suite requires a bash version >= 4.0"
19 echo "due to use of associative arrays within the test suite."
20 echo "Please try again with a newer bash (or help us fix the"
21 echo "test suite to be more portable). Thanks."
25 # Make sure echo builtin does not expand backslash-escape sequences by default.
29 this_test=${this_test%.sh}
30 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
32 # if --tee was passed, write the output not only to the terminal, but
33 # additionally to the file test-results/$BASENAME.out, too.
34 case "$GIT_TEST_TEE_STARTED, $* " in
36 # do not redirect again
38 *' --tee '*|*' --va'*)
40 BASE=test-results/$this_test
41 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
42 echo $? > $BASE.exit) | tee $BASE.out
43 test "$(cat $BASE.exit)" = 0
48 # Save STDOUT to fd 6 and STDERR to fd 7.
50 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
52 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
54 # Keep the original TERM for say_color and test_emacs
57 # dtach(1) provides more capable terminal environment to anything
58 # that requires more than dumb terminal...
59 [ x"${TERM:-dumb}" = xdumb ] && DTACH_TERM=vt100 || DTACH_TERM=$TERM
61 # For repeatability, reset the environment to known value.
67 export LANG LC_ALL PAGER TERM TZ
68 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
69 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
70 ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
71 echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
74 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
75 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
76 TEST_CC=${TEST_CC:-cc}
77 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
79 # Protect ourselves from common misconfiguration to export
80 # CDPATH into the environment
87 # A regexp to match 5 and 40 hexdigits
88 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
89 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
91 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
92 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
94 # Each test should start with something like this, after copyright notices:
96 # test_description='Description of this test...
97 # This test checks if command xyzzy does the right thing...
99 # . ./test-lib.sh || exit 1
101 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
102 TERM=$ORIGINAL_TERM &&
105 tput bold >/dev/null 2>&1 &&
106 tput setaf 1 >/dev/null 2>&1 &&
107 tput sgr0 >/dev/null 2>&1
111 while test "$#" -ne 0
114 -d|--d|--de|--deb|--debu|--debug)
116 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
117 immediate=t; shift ;;
118 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
119 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
120 -h|--h|--he|--hel|--help)
122 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
124 -q|--q|--qu|--qui|--quie|--quiet)
127 with_dashes=t; shift ;;
133 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
134 valgrind=t; verbose=t; shift ;;
136 shift ;; # was handled already
138 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
141 echo "error: unknown test option '$1'" >&2; exit 1 ;;
145 if test -n "$debug"; then
147 printf " %-4s" "[$((test_count - 1))]"
155 if test -n "$color"; then
161 error) tput bold; tput setaf 1;; # bold red
162 skip) tput bold; tput setaf 2;; # bold green
163 pass) tput setaf 2;; # green
164 info) tput setaf 3;; # brown
165 *) test -n "$quiet" && return;;
176 test -z "$1" && test -n "$quiet" && return
185 say_color error "error: $*\n"
194 test "${test_description}" != "" ||
195 error "Test script did not set test_description."
197 if test "$help" = "t"
199 echo "Tests ${test_description}"
203 test_description_printed=
204 print_test_description ()
206 test -z "$test_description_printed" || return 0
208 echo $this_test: "Testing ${test_description}"
209 test_description_printed=1
211 if [ -z "$NOTMUCH_TEST_QUIET" ]
213 print_test_description
226 rm -rf "$TEST_TMPDIR"
231 if test -n "$GIT_EXIT_OK"
236 say_color error '%-6s' FATAL
237 echo " $test_subtest_name"
239 echo "Unexpected exit while executing $0. Exit code $code."
246 echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
251 # Note: TEST_TMPDIR *NOT* exported!
252 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
254 trap 'die_signal' HUP INT TERM
256 test_decode_color () {
257 sed -e 's/.\[1m/<WHITE>/g' \
258 -e 's/.\[31m/<RED>/g' \
259 -e 's/.\[32m/<GREEN>/g' \
260 -e 's/.\[33m/<YELLOW>/g' \
261 -e 's/.\[34m/<BLUE>/g' \
262 -e 's/.\[35m/<MAGENTA>/g' \
263 -e 's/.\[36m/<CYAN>/g' \
264 -e 's/.\[m/<RESET>/g'
276 sed -e 's/$/Q/' | tr Q '\015'
280 tr '\015' Q | sed -e 's/Q$//'
283 # Generate a new message in the mail directory, with a unique message
284 # ID and subject. The message is not added to the index.
286 # After this function returns, the filename of the generated message
287 # is available as $gen_msg_filename and the message ID is available as
290 # This function supports named parameters with the bash syntax for
291 # assigning a value to an associative array ([name]=value). The
292 # supported parameters are:
294 # [dir]=directory/of/choice
296 # Generate the message in directory 'directory/of/choice' within
297 # the mail store. The directory will be created if necessary.
301 # Store the message in file 'name'. The default is to store it
302 # in 'msg-<count>', where <count> is three-digit number of the
307 # Text to use as the body of the email message
309 # '[from]="Some User <user@example.com>"'
310 # '[to]="Some User <user@example.com>"'
311 # '[subject]="Subject of email message"'
312 # '[date]="RFC 822 Date"'
314 # Values for email headers. If not provided, default values will
315 # be generated instead.
317 # '[cc]="Some User <user@example.com>"'
318 # [reply-to]=some-address
319 # [in-reply-to]=<message-id>
320 # [references]=<message-id>
321 # [content-type]=content-type-specification
322 # '[header]=full header line, including keyword'
324 # Additional values for email headers. If these are not provided
325 # then the relevant headers will simply not appear in the
330 # Controls the message-id of the created message.
336 # This is our (bash-specific) magic for doing named parameters
337 local -A template="($@)"
338 local additional_headers
340 gen_msg_cnt=$((gen_msg_cnt + 1))
341 if [ -z "${template[filename]}" ]; then
342 gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
344 gen_msg_name=${template[filename]}
347 if [ -z "${template[id]}" ]; then
348 gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
350 gen_msg_id="${template[id]}"
353 if [ -z "${template[dir]}" ]; then
354 gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
356 gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
357 mkdir -p "$(dirname "$gen_msg_filename")"
360 if [ -z "${template[body]}" ]; then
361 template[body]="This is just a test message (#${gen_msg_cnt})"
364 if [ -z "${template[from]}" ]; then
365 template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
368 if [ -z "${template[to]}" ]; then
369 template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
372 if [ -z "${template[subject]}" ]; then
373 if [ -n "$test_subtest_name" ]; then
374 template[subject]="$test_subtest_name"
376 template[subject]="Test message #${gen_msg_cnt}"
378 elif [ "${template[subject]}" = "@FORCE_EMPTY" ]; then
382 if [ -z "${template[date]}" ]; then
383 # we use decreasing timestamps here for historical reasons;
384 # the existing test suite when we converted to unique timestamps just
385 # happened to have signicantly fewer failures with that choice.
386 local date_secs=$((978709437 - gen_msg_cnt))
387 # printf %(..)T is bash 4.2+ feature. use perl fallback if needed...
388 TZ=UTC printf -v template[date] "%(%a, %d %b %Y %T %z)T" $date_secs 2>/dev/null ||
389 template[date]=`perl -le 'use POSIX "strftime";
390 @time = gmtime '"$date_secs"';
391 print strftime "%a, %d %b %Y %T +0000", @time'`
394 additional_headers=""
395 if [ ! -z "${template[header]}" ]; then
396 additional_headers="${template[header]}
397 ${additional_headers}"
400 if [ ! -z "${template[reply-to]}" ]; then
401 additional_headers="Reply-To: ${template[reply-to]}
402 ${additional_headers}"
405 if [ ! -z "${template[in-reply-to]}" ]; then
406 additional_headers="In-Reply-To: ${template[in-reply-to]}
407 ${additional_headers}"
410 if [ ! -z "${template[cc]}" ]; then
411 additional_headers="Cc: ${template[cc]}
412 ${additional_headers}"
415 if [ ! -z "${template[bcc]}" ]; then
416 additional_headers="Bcc: ${template[bcc]}
417 ${additional_headers}"
420 if [ ! -z "${template[references]}" ]; then
421 additional_headers="References: ${template[references]}
422 ${additional_headers}"
425 if [ ! -z "${template[content-type]}" ]; then
426 additional_headers="Content-Type: ${template[content-type]}
427 ${additional_headers}"
430 if [ ! -z "${template[content-transfer-encoding]}" ]; then
431 additional_headers="Content-Transfer-Encoding: ${template[content-transfer-encoding]}
432 ${additional_headers}"
435 # Note that in the way we're setting it above and using it below,
436 # `additional_headers' will also serve as the header / body separator
437 # (empty line in between).
439 cat <<EOF >"$gen_msg_filename"
440 From: ${template[from]}
442 Message-Id: <${gen_msg_id}>
443 Subject: ${template[subject]}
444 Date: ${template[date]}
445 ${additional_headers}
450 # Generate a new message and add it to the database.
452 # All of the arguments and return values supported by generate_message
453 # are also supported here, so see that function for details.
456 generate_message "$@" &&
457 notmuch new > /dev/null
460 # Deliver a message with emacs and add it to the database
462 # Uses emacs to generate and deliver a message to the mail store.
463 # Accepts arbitrary extra emacs/elisp functions to modify the message
464 # before sending, which is useful to doing things like attaching files
465 # to the message and encrypting/signing.
466 emacs_deliver_message ()
471 # before we can send a message, we have to prepare the FCC maildir
472 mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
473 # eval'ing smtp-dummy --background will set smtp_dummy_pid
475 eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
476 test -n "$smtp_dummy_pid" || return 1
479 "(let ((message-send-mail-function 'message-smtpmail-send-it)
480 (mail-host-address \"example.com\")
481 (smtpmail-smtp-server \"localhost\")
482 (smtpmail-smtp-service \"25025\"))
485 (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
486 (message-goto-subject)
487 (insert \"${subject}\")
491 (notmuch-mua-send-and-exit))"
493 # In case message was sent properly, client waits for confirmation
494 # before exiting and resuming control here; therefore making sure
495 # that server exits by sending (KILL) signal to it is safe.
496 kill -9 $smtp_dummy_pid
497 notmuch new >/dev/null
500 # Pretend to deliver a message with emacs. Really save it to a file
501 # and add it to the database
503 # Uses emacs to generate and deliver a message to the mail store.
504 # Accepts arbitrary extra emacs/elisp functions to modify the message
505 # before sending, which is useful to doing things like attaching files
506 # to the message and encrypting/signing.
512 # before we can send a message, we have to prepare the FCC maildir
513 mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
516 "(let ((message-send-mail-function (lambda () t))
517 (mail-host-address \"example.com\"))
520 (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
521 (message-goto-subject)
522 (insert \"${subject}\")
526 (notmuch-mua-send-and-exit))" || return 1
527 notmuch new >/dev/null
530 # Generate a corpus of email and add it to the database.
532 # This corpus is fixed, (it happens to be 50 messages from early in
533 # the history of the notmuch mailing list), which allows for reliably
534 # testing commands that need to operate on a not-totally-trivial
535 # number of messages.
539 if [ -d $TEST_DIRECTORY/corpus.mail ]; then
540 cp -a $TEST_DIRECTORY/corpus.mail ${MAIL_DIR}
542 cp -a $TEST_DIRECTORY/corpus ${MAIL_DIR}
543 notmuch new >/dev/null
544 cp -a ${MAIL_DIR} $TEST_DIRECTORY/corpus.mail
548 test_begin_subtest ()
550 if [ -n "$inside_subtest" ]; then
551 exec 1>&6 2>&7 # Restore stdout and stderr
552 error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
554 test_subtest_name="$1"
556 # Redirect test output to the previously prepared file descriptors
557 # 3 and 4 (see below)
558 if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
563 # Pass test if two arguments match
565 # Note: Unlike all other test_expect_* functions, this function does
566 # not accept a test name. Instead, the caller should call
567 # test_begin_subtest before calling this function in order to set the
571 exec 1>&6 2>&7 # Restore stdout and stderr
573 test "$#" = 3 && { prereq=$1; shift; } || prereq=
575 error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
579 if ! test_skip "$test_subtest_name"
581 if [ "$output" = "$expected" ]; then
584 testname=$this_test.$test_count
585 echo "$expected" > $testname.expected
586 echo "$output" > $testname.output
587 test_failure_ "$(diff -u $testname.expected $testname.output)"
592 # Like test_expect_equal, but takes two filenames.
593 test_expect_equal_file ()
595 exec 1>&6 2>&7 # Restore stdout and stderr
597 test "$#" = 3 && { prereq=$1; shift; } || prereq=
599 error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
602 basename1=`basename "$file1"`
604 basename2=`basename "$file2"`
605 if ! test_skip "$test_subtest_name"
607 if diff -q "$file1" "$file2" >/dev/null ; then
610 testname=$this_test.$test_count
611 cp "$file1" "$testname.$basename1"
612 cp "$file2" "$testname.$basename2"
613 test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
618 # Like test_expect_equal, but arguments are JSON expressions to be
619 # canonicalized before diff'ing. If an argument cannot be parsed, it
620 # is used unchanged so that there's something to diff against.
621 test_expect_equal_json () {
622 # The test suite forces LC_ALL=C, but this causes Python 3 to
623 # decode stdin as ASCII. We need to read JSON in UTF-8, so
624 # override Python's stdio encoding defaults.
625 output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -mjson.tool \
627 expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -mjson.tool \
630 test_expect_equal "$output" "$expected" "$@"
633 # Sort the top-level list of JSON data from stdin.
635 PYTHONIOENCODING=utf-8 python -c \
636 "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
639 test_emacs_expect_t () {
640 test "$#" = 2 && { prereq=$1; shift; } || prereq=
642 error "bug in the test script: not 1 or 2 parameters to test_emacs_expect_t"
645 if ! test_skip "$test_subtest_name"
647 test_emacs "(notmuch-test-run $1)" >/dev/null
649 # Restore state after the test.
650 exec 1>&6 2>&7 # Restore stdout and stderr
653 # Report success/failure.
659 test_failure_ "${result}"
662 # Restore state after the (non) test.
663 exec 1>&6 2>&7 # Restore stdout and stderr
670 notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
673 notmuch_search_sanitize ()
675 perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
678 notmuch_search_files_sanitize()
680 sed -e "s,$MAIL_DIR,MAIL_DIR,"
683 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
684 notmuch_show_sanitize ()
686 sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
688 notmuch_show_sanitize_all ()
691 -e 's| filename:.*| filename:XXXXX|' \
692 -e 's| id:[^ ]* | id:XXXXX |' | \
693 notmuch_date_sanitize
696 notmuch_json_show_sanitize ()
699 -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
700 -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
701 -e 's|"filename": "signature.asc",||g' \
702 -e 's|"filename": "/[^"]*",|"filename": "YYYYY",|g' \
703 -e 's|"timestamp": 97.......|"timestamp": 42|g'
706 notmuch_emacs_error_sanitize ()
714 -e 's/^\[.*\]$/[XXX]/' \
715 -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
718 notmuch_date_sanitize ()
721 -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
724 notmuch_uuid_sanitize ()
726 sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
728 # End of notmuch helper functions
730 # Use test_set_prereq to tell that a particular prerequisite is available.
731 # The prerequisite can later be checked for in two ways:
733 # - Explicitly using test_have_prereq.
735 # - Implicitly by specifying the prerequisite tag in the calls to
736 # test_expect_{success,failure,code}.
738 # The single parameter is the prerequisite tag (a simple word, in all
739 # capital letters by convention).
742 satisfied="$satisfied$1 "
746 test_have_prereq () {
755 declare -A test_missing_external_prereq_
756 declare -A test_subtest_missing_external_prereq_
758 # declare prerequisite for the given external binary
759 test_declare_external_prereq () {
761 test "$#" = 2 && name=$2 || name="$binary(1)"
763 if ! hash $binary 2>/dev/null; then
764 test_missing_external_prereq_["${binary}"]=t
767 test_subtest_missing_external_prereq_[\"${name}\"]=t
773 # Explicitly require external prerequisite. Useful when binary is
774 # called indirectly (e.g. from emacs).
775 # Returns success if dependency is available, failure otherwise.
776 test_require_external_prereq () {
778 if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
779 # dependency is missing, call the replacement function to note it
786 # You are not expected to call test_ok_ and test_failure_ directly, use
787 # the text_expect_* functions instead.
790 if test "$test_subtest_known_broken_" = "t"; then
791 test_known_broken_ok_
794 test_success=$(($test_success + 1))
795 if test -n "$NOTMUCH_TEST_QUIET"; then
798 say_color pass "%-6s" "PASS"
799 echo " $test_subtest_name"
803 if test "$test_subtest_known_broken_" = "t"; then
804 test_known_broken_failure_ "$@"
807 test_failure=$(($test_failure + 1))
808 print_test_description
809 test_failure_message_ "FAIL" "$test_subtest_name" "$@"
810 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
814 test_failure_message_ () {
815 say_color error "%-6s" "$1"
818 echo "$@" | sed -e 's/^/ /'
819 if test "$verbose" != "t"; then cat test.output; fi
822 test_known_broken_ok_ () {
824 test_fixed=$(($test_fixed+1))
825 say_color pass "%-6s" "FIXED"
826 echo " $test_subtest_name"
829 test_known_broken_failure_ () {
831 test_broken=$(($test_broken+1))
832 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
837 test "$debug" = "" || eval "$1"
842 if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
845 eval >&3 2>&4 "$test_cleanup"
850 test_count=$(($test_count+1))
852 for skp in $NOTMUCH_SKIP_TESTS
854 case $this_test.$test_count in
859 case $this_test_bare.$test_count in
865 if test -z "$to_skip" && test -n "$prereq" &&
866 ! test_have_prereq "$prereq"
872 test_report_skip_ "$@"
875 test_check_missing_external_prereqs_ "$@"
880 test_check_missing_external_prereqs_ () {
881 if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
882 say_color skip >&1 "missing prerequisites: "
883 echo ${!test_subtest_missing_external_prereq_[@]} >&1
884 test_report_skip_ "$@"
890 test_report_skip_ () {
892 say_color skip >&3 "skipping test:"
894 say_color skip "%-6s" "SKIP"
898 test_subtest_known_broken () {
899 test_subtest_known_broken_=t
902 test_expect_success () {
903 test "$#" = 3 && { prereq=$1; shift; } || prereq=
905 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
906 test_subtest_name="$1"
912 # test_run_ may update missing external prerequisites
913 test_check_missing_external_prereqs_ "$@" ||
914 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
923 test_expect_code () {
924 test "$#" = 4 && { prereq=$1; shift; } || prereq=
926 error "bug in the test script: not 3 or 4 parameters to test-expect-code"
927 test_subtest_name="$2"
933 # test_run_ may update missing external prerequisites,
934 test_check_missing_external_prereqs_ "$@" ||
935 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
939 test_failure_ "exit code $eval_ret, expected $1" "$3"
944 # test_external runs external test scripts that provide continuous
945 # test output about their progress, and succeeds/fails on
946 # zero/non-zero exit code. It outputs the test output on stdout even
947 # in non-verbose mode, and announces the external script with "* run
948 # <n>: ..." before running it. When providing relative paths, keep in
949 # mind that all scripts run in "trash directory".
950 # Usage: test_external description command arguments...
951 # Example: test_external 'Perl API' perl ../path/to/test.pl
953 test "$#" = 4 && { prereq=$1; shift; } || prereq=
955 error >&6 "bug in the test script: not 3 or 4 parameters to test_external"
956 test_subtest_name="$1"
959 if ! test_skip "$test_subtest_name" "$@"
961 # Announce the script to reduce confusion about the
962 # test output that follows.
963 say_color "" " run $test_count: $descr ($*)"
964 # Run command; redirect its stderr to &4 as in
965 # test_run_, but keep its stdout on our stdout even in
977 # Like test_external, but in addition tests that the command generated
978 # no output on stderr.
979 test_external_without_stderr () {
980 # The temporary file has no (and must have no) security
982 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
983 stderr="$tmp/git-external-stderr.$$.tmp"
984 test_external "$@" 4> "$stderr"
985 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
986 test_subtest_name="no stderr: $1"
988 if [ ! -s "$stderr" ]; then
992 if [ "$verbose" = t ]; then
993 output=`echo; echo Stderr is:; cat "$stderr"`
997 # rm first in case test_failure exits.
999 test_failure_ "$@" "$output"
1003 # This is not among top-level (test_expect_success)
1004 # but is a prefix that can be used in the test script, like:
1006 # test_expect_success 'complain and die' '
1008 # do something else &&
1009 # test_must_fail git checkout ../outerspace
1012 # Writing this as "! git checkout ../outerspace" is wrong, because
1013 # the failure could be due to a segv. We want a controlled failure.
1017 test $? -gt 0 -a $? -le 129 -o $? -gt 192
1020 # test_cmp is a helper function to compare actual and expected output.
1021 # You can use it like:
1023 # test_expect_success 'foo works' '
1024 # echo expected >expected &&
1026 # test_cmp expected actual
1029 # This could be written as either "cmp" or "diff -u", but:
1030 # - cmp's output is not nearly as easy to read as diff -u
1031 # - not all diff versions understand "-u"
1037 # This function can be used to schedule some commands to be run
1038 # unconditionally at the end of the test to restore sanity:
1040 # test_expect_success 'test core.capslock' '
1041 # git config core.capslock true &&
1042 # test_when_finished "git config --unset core.capslock" &&
1046 # That would be roughly equivalent to
1048 # test_expect_success 'test core.capslock' '
1049 # git config core.capslock true &&
1051 # git config --unset core.capslock
1054 # except that the greeting and config --unset must both succeed for
1057 test_when_finished () {
1059 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
1064 test_results_dir="$TEST_DIRECTORY/test-results"
1065 mkdir -p "$test_results_dir"
1066 test_results_path="$test_results_dir/$this_test"
1068 echo "total $test_count" >> $test_results_path
1069 echo "success $test_success" >> $test_results_path
1070 echo "fixed $test_fixed" >> $test_results_path
1071 echo "broken $test_broken" >> $test_results_path
1072 echo "failed $test_failure" >> $test_results_path
1073 echo "" >> $test_results_path
1075 [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
1077 if [ "$test_failure" = "0" ]; then
1078 if [ "$test_broken" = "0" ]; then
1079 rm -rf "$remove_tmp"
1087 emacs_generate_script () {
1088 # Construct a little test script here for the benefit of the user,
1089 # (who can easily run "run_emacs" to get the same emacs environment
1090 # for investigating any failures).
1091 cat <<EOF >"$TMP_DIRECTORY/run_emacs"
1094 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
1096 # Here's what we are using here:
1098 # --quick Use minimal customization. This implies --no-init-file,
1099 # --no-site-file and (emacs 24) --no-site-lisp
1101 # --directory Ensure that the local elisp sources are found
1103 # --load Force loading of notmuch.el and test-lib.el
1105 exec ${TEST_EMACS} --quick \
1106 --directory "$TEST_DIRECTORY/../emacs" --load notmuch.el \
1107 --directory "$TEST_DIRECTORY" --load test-lib.el \
1110 chmod a+x "$TMP_DIRECTORY/run_emacs"
1114 # test dependencies beforehand to avoid the waiting loop below
1115 missing_dependencies=
1116 test_require_external_prereq dtach || missing_dependencies=1
1117 test_require_external_prereq emacs || missing_dependencies=1
1118 test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
1119 test -z "$missing_dependencies" || return
1121 if [ -z "$EMACS_SERVER" ]; then
1122 emacs_tests="${this_test_bare}.el"
1123 if [ -f "$TEST_DIRECTORY/$emacs_tests" ]; then
1124 load_emacs_tests="--eval '(load \"$emacs_tests\")'"
1128 server_name="notmuch-test-suite-$$"
1129 # start a detached session with an emacs server
1130 # user's TERM (or 'vt100' in case user's TERM is unset, empty
1131 # or 'dumb') is given to dtach which assumes a minimally
1132 # VT100-compatible terminal -- and emacs inherits that
1133 TERM=$DTACH_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
1134 sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
1135 --no-window-system \
1137 --eval '(setq server-name \"$server_name\")' \
1138 --eval '(server-start)' \
1139 --eval '(orphan-watchdog $$)'" || return
1140 EMACS_SERVER="$server_name"
1141 # wait until the emacs server is up
1142 until test_emacs '()' >/dev/null 2>/dev/null; do
1147 # Clear test-output output file. Most Emacs tests end with a
1148 # call to (test-output). If the test code fails with an
1149 # exception before this call, the output file won't get
1150 # updated. Since we don't want to compare against an output
1151 # file from another test, so start out with an empty file.
1155 ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(notmuch-test-progn $@)"
1159 export LD_LIBRARY_PATH=$TEST_DIRECTORY/../lib
1160 export PYTHONPATH=$TEST_DIRECTORY/../bindings/python
1162 (echo "import sys; _orig_stdout=sys.stdout; sys.stdout=open('OUTPUT', 'w')"; cat) \
1167 export LD_LIBRARY_PATH=$TEST_DIRECTORY/../lib
1168 MAIL_DIR=$MAIL_DIR ruby -I $TEST_DIRECTORY/../bindings/ruby> OUTPUT
1172 exec_file="test${test_count}"
1173 test_file="${exec_file}.c"
1175 export LD_LIBRARY_PATH=${TEST_DIRECTORY}/../lib
1176 ${TEST_CC} ${TEST_CFLAGS} -I${TEST_DIRECTORY}/../lib -o ${exec_file} ${test_file} -L${TEST_DIRECTORY}/../lib/ -lnotmuch -ltalloc
1177 echo "== stdout ==" > OUTPUT.stdout
1178 echo "== stderr ==" > OUTPUT.stderr
1179 ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
1180 sed "s,${PWD},CWD,g" OUTPUT.stdout OUTPUT.stderr > OUTPUT
1184 # Creates a script that counts how much time it is executed and calls
1185 # notmuch. $notmuch_counter_command is set to the path to the
1186 # generated script. Use notmuch_counter_value() function to get the
1187 # current counter value.
1188 notmuch_counter_reset () {
1189 notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1190 if [ ! -x "$notmuch_counter_command" ]; then
1191 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1192 cat >"$notmuch_counter_command" <<EOF || return
1195 read count < "$notmuch_counter_state_path"
1196 echo \$((count + 1)) > "$notmuch_counter_state_path"
1200 chmod +x "$notmuch_counter_command" || return
1203 echo 0 > "$notmuch_counter_state_path"
1206 # Returns the current notmuch counter value.
1207 notmuch_counter_value () {
1208 if [ -r "$notmuch_counter_state_path" ]; then
1209 read count < "$notmuch_counter_state_path"
1216 test_reset_state_ () {
1217 test -z "$test_init_done_" && test_init_
1219 test_subtest_known_broken_=
1220 test_subtest_missing_external_prereq_=()
1223 # called once before the first subtest
1227 # skip all tests if there were external prerequisites missing during init
1228 test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1232 . ./test-lib-common.sh || exit 1
1234 emacs_generate_script
1237 # Use -P to resolve symlinks in our working directory so that the cwd
1238 # in subprocesses like git equals our $PWD (for pathname comparisons).
1239 cd -P "$test" || error "Cannot set up test environment"
1241 if test "$verbose" = "t"
1245 exec 4>test.output 3>&4
1248 for skp in $NOTMUCH_SKIP_TESTS
1251 for skp in $NOTMUCH_SKIP_TESTS
1253 case "$this_test" in
1258 case "$this_test_bare" in
1266 say_color skip >&3 "skipping test $this_test altogether"
1267 say_color skip "skip all tests in $this_test"
1272 # Provide an implementation of the 'yes' utility
1287 # Fix some commands on Windows
1290 # Windows has its own (incompatible) sort and find
1300 # git sees Windows-style pwd
1304 # no POSIX permissions
1305 # backslashes in pathspec are converted to '/'
1306 # exec does not inherit the PID
1309 test_set_prereq POSIXPERM
1310 test_set_prereq BSLASHPSPEC
1311 test_set_prereq EXECKEEPSPID
1315 test -z "$NO_PERL" && test_set_prereq PERL
1316 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1318 # test whether the filesystem supports symbolic links
1319 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1322 # declare prerequisites for external binaries used in tests
1323 test_declare_external_prereq dtach
1324 test_declare_external_prereq emacs
1325 test_declare_external_prereq ${TEST_EMACSCLIENT}
1326 test_declare_external_prereq gdb
1327 test_declare_external_prereq gpg
1328 test_declare_external_prereq ${NOTMUCH_PYTHON}